<?php
if ( ! class_exists( 'WPClassifiedsUpdates' ) ) {
	class WPClassifiedsUpdates {

		var $api_url;

			var $plugin_path;
		var $plugin_slug = TEVOLUTION_CLASSIFIEDS_SLUG;
		var $plugin_version = TEVOLUTION_CLASSIFIEDS_VERSION;
		function __construct( $api_url, $plugin_path ) {
			$plugin_path = plugin_dir_path( __FILE__ );
			$plugin_file = $plugin_path . 'classifieds.php';
			$plugin_data = get_plugin_data( $plugin_file, $markup = true, $translate = true );
			$plugin_version = $plugin_data['Version'];
			$this->api_url = $api_url;
			$this->plugin_path = $plugin_path;
			if ( strstr( $plugin_path, '/' ) ) { list ($t1, $t2) = explode( '/', $plugin_path );
			} else { $t2 = $plugin_path;
			}

				add_filter( 'pre_set_site_transient_update_plugins', array( &$this, 'classifieds_check_for_update' ) );
			add_filter( 'plugins_api', array( &$this, 'classifieds_plugin_api_call' ), 10, 3 );

			if ( is_network_admin() || ! is_multisite() ) {
				add_action( 'after_plugin_row_' . TEVOLUTION_CLASSIFIEDS_SLUG, array( &$this, 'classifieds_plugin_row' ),10,3 );
			}
		}


		/*
        * add action for set the auto update for tevolution plug in
        * Function Name: tevolution_plugin_row
        * Return : Display the plug in new version update message
		*/
		function classifieds_plugin_row( $plugin_file, $plugin_data, $status ) {
			/*check the remote version*/
			 global $plugin_response;
			 $current = get_site_transient( 'update_plugins' );
			 $r = @$current->response[ $plugin_file ];
			 $remote_version = @$r->new_version;
			if ( version_compare( $this->plugin_version , $remote_version, '<' ) ) {
				$new_version = version_compare( $this->plugin_version , $remote_version, '<' ) ? __( 'There is a new version of Tevolution-Classifieds plugin available ', 'classifieds' )  : '';

				$ajax_url = esc_url( add_query_arg( array(
					'slug' => 'classified',
					'action' => 'classified',
					'_ajax_nonce' => wp_create_nonce( 'classified' ),
					'TB_iframe' => true,
					'width' => 500,
					'height' => 400,
				), admin_url( 'admin-ajax.php' ) ) );
				$file = 'Tevolution-Classifieds/classifieds.php';
				$download = wp_nonce_url( self_admin_url( 'update.php?action=upgrade-plugin&plugin=' ) . $file, 'upgrade-plugin_' . $file );
				echo '<tr class="plugin-update-tr active templatic-updates" id="-update"><td colspan="3" class="plugin-update colspanchange"><div class="update-message notice inline notice-warning notice-alt"><p>' . $new_version . ' <a href="' . $ajax_url . '" class="thickbox" title="Templatic Classifieds Plugin Update">' . __( 'update now','templatic' ) . '</a></p></div></td></tr>';

			}
		}

		function classifieds_check_for_update( $transient ) {
			global $plugin_response,$wp_version;
			$request_args = array(
			'slug' => $this->plugin_slug,
			'version' => $transient->checked[ $this->plugin_slug ],
			);
			$request_string = $this->classifieds_prepare_request( 'templatic_plugin_update', $request_args );

			$raw_response = wp_remote_post( $this->api_url, $request_string );
			$response = null;
			if ( ! is_wp_error( $raw_response ) && ($raw_response['response']['code'] == 200) ) {
				$response = json_decode( $raw_response['body'] );
			}

			if ( ! empty( $response ) ) {/* Feed the update data into WP updater*/
				$transient->response[ $this->plugin_slug ] = $response;
				$plugin_response[ $this->plugin_slug ] = (array) $response;
				update_option( $this->plugin_slug . '_theme_version',$plugin_response );
			}
			return $transient;
		}

		function classifieds_plugin_api_call( $def, $action, $args ) {
			if ( ! isset( $args->slug ) || $args->slug != $this->plugin_slug ) { return $def;
			}

			$plugin_info = get_site_transient( 'update_plugins' );
			$request_args = array(
			'slug' => $this->plugin_slug,
			'version' => (isset( $plugin_info->checked )) ? $plugin_info->checked[ $this->plugin_path ] : 0 /* Current version*/,
			);

			$request_string = $this->classifieds_prepare_request( $action, $request_args );
			$raw_response = wp_remote_post( $this->api_url, $request_string );
			if ( is_wp_error( $raw_response ) ) {
				$res = new WP_Error( 'plugins_api_failed', __( 'An Unexpected HTTP Error occurred during the API request.','classifieds' ) . '</p><p><a href="?" onclick="document.location.reload(); return false;">' . __( 'Try again','classifieds' ) . '</a>', $raw_response->get_error_message() );

			} else {
				$res = json_decode( $raw_response['body'] );
				if ( $res === false ) {
					$res = new WP_Error( 'plugins_api_failed', __( 'An unknown error occurred', 'classifieds' ), $raw_response['body'] );
				}
			}
			return $res;
		}

		function classifieds_prepare_request( $action, $args ) {
			global $wp_version;

			return array(
			'body' => array(
				'action' => $action,
				'request' => serialize( $args ),
				'api-key' => md5( home_url() ),
			),
			'user-agent' => 'WordPress/' . $wp_version . '; ' . home_url(),
			);
		}
	}
}// End if().

